%%%% nou_int_rpo.pl :: programa per generacio de l'ordre de base 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% USES : a_intrpo, precstat, cycles, rpo13fix, simp_int, list, rpo
%	 (ordre: is_variable)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  int_rpo(Const_rules,Const_cycles,LIntsfix0,LIntsfixOut,Prec0,PrecOut,Stat0,StatOut)
%  generar_prec1(Symb,Const,Prec,PrecOut,Stat,StatOut)
%  simplify_and_check1(Crules,LInts,LIntsfix,CrulesOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut),
%  simplify_and_check2(Crules,Ccycles,LInts,LIntsfix,CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut),	
%  set_int_leftisvar1(LConst,LInts,LIntsfix,LConstOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut)
%  set_int_leftisvar2(Crules,Ccycles,LInts,LIntsfix,CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut)
%  check_rules(LRules,LInts,Prec,Stat,LRules0,LRulesOut)
%  trivial(Const,LInts)
%  interpret(LConst,Isymbs,LConstInt0,LConstIntOut)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


:-dynamic leftR/1.
:-dynamic noleftR/1.
:-dynamic renamed/1.
:-dynamic variables/1.

% Const_rules : [l1>=r1,...,ln>=rn,u1>v1,..]
%	u1>v1,.. obtained by contradicting a possible cycle
%		(when innermost).
% Const_cycles : [s1>t1,s2>=t2,...] top(si),top(ti) are renamed

% considerem que no hi pot haver un smbol amb dues aritats diferents.

int_rpo(Const_rules,Const_cycles,LIntsfix0,LIntsfixOut,Prec0,PrecOut,Stat0,StatOut):-
	obt_Int_and_interp(LIntsfix0,Const_rules,Const_cycles,LInts,LIntsfix,Crules,Ccycles),
	simplify_and_check2(Crules,Ccycles,LInts,LIntsfix,
			Crules1,Ccycles1,LInts1,LIntsfix1,Prec0,Stat0,Prec1,Stat1),
	set_int_leftisvar2(Crules1,Ccycles1,LInts1,LIntsfix1,
		Crules2,Ccycles2,LInts2,LIntsfix2,Prec1,Stat1,Prec2,Stat2),
 	set_trivial_int_rules(Crules2,Ccycles2,LInts2,LIntsfix2,Prec2,Stat2,
			Crules22,Ccycles22,LInts22,LIntsfix22,Prec22,Stat22),
	obt_def_tofix(Deftofix,LIntsfix22),
	base_rules(Deftofix,Crules22,Ccycles22,Crules3,Ccycles3,
		LInts22,LInts3,LIntsfix22,LIntsfix3,Prec22,Prec3,Stat22,Stat3),
   	set_Int_cycles(Ccycles3,Crules3,Crules4,LInts3,LInts4,LIntsfix3,LIntsfix4,
			Prec3,Prec4,Stat3,Stat4),
  	simplify_vars_rhs(Crules4,LInts4,LInts5,LIntsfix4,LIntsfix5,Crules5,
			Prec4,Stat4,Prec5,Stat5),
 	set_trivial_int_rules(Crules5,[],LInts5,LIntsfix5,Prec5,Stat5,
			Crules55,[],LInts55,LIntsfix55,Prec55,Stat55),
  	fix_interp(LInts55,LIntsfix55,LIntsfixOut,Crules55,Crules6,Prec55,Stat55,Prec6,Stat6),
	elim_symbs_no_exist(LIntsfixOut,Prec6,Prec7,Stat6,Stat7),  
	try_rpo(Crules6,Prec7,Stat7,PrecOut,StatOut).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

obt_Int_and_interp([],CRules,CCyc,LIntsOut,LIntsfixOut,CRules,CCyc):-
	gen_int_symbols(LInts,[]),
    	selecc_fixed1_ints(LInts,[],LIntsOut,[],LIntsfixOut),!.
obt_Int_and_interp(LIntsfix,CRules,CCyc,LIntsOut,LIntsfixOut,CRulesOut,CCycOut):-
	map(head2,LIntsfix,LSymbs),
	renamed(Ren),
	inter(LSymbs,Ren,Renfixed),
	separ_proj_renamed(Renfixed,LIntsfix,LIntsprojren),
	act_interpret(CRules,CCyc,LIntsfix,LIntsprojren,CRulesOut,CCycOut),!,
	gen_int_symbols(LInts,LSymbs),
    	selecc_fixed1_ints(LInts,[],LIntsOut,LIntsfix,LIntsfixOut),!.


obt_def_tofix(D,LIntsfix):-
	leftR(Def),
	map(head2,LIntsfix,S_fixed),
	difer(Def,S_fixed,D),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% definedR, constructorsR and renamed contain a List of pairs [Symbol,Arity]


gen_int_symbols(L,LSymbs):- 
	leftR(Def), noleftR(Cons), renamed(Ren),
	difer(Ren,LSymbs,R),
	gen_int_symbols(R,[],L1),
	difer(Def,LSymbs,D),
	gen_int_symbols(D,L1,L3),
	difer(Cons,LSymbs,C),
	gen_int_symbols(C,L3,L),!.

gen_int_symbols([],L,L):-!.
gen_int_symbols([[S,Ar]|R],L1,LOut):- 
	int_arity(Ar,L), 
	gen_int_symbols(R,[[S,Ar,L]|L1],LOut),!.


simplify_int_ren_symbols([],L,L):-!.
simplify_int_ren_symbols([[S,Ar]|Rest],L1,L):-
	delete32([S,Ar,LIntsS],L1,L11),
	crearlistNK(Ar,0,L0),
	delete32([1|L0],LIntsS,LIntsS1),
	simplify_int_ren_symbols(Rest,[[S,Ar,LIntsS1]|L11],L),!.

selec_stricts([],[],[]):-!.
selec_stricts([C|Rc],[C|R1],R2):-C=..[>|_],!, 
			selec_stricts(Rc,R1,R2).
selec_stricts([C|Rc],R1,[C|R2]):-selec_stricts(Rc,R1,R2),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% S'agafa el mxim conjunt S de regles L>=R tals que els tops de L i R
% no apareixin en cap altra regla fora de S. 
% Per tots aquests tops es fixa interpretaci de projecci al top i es
% genera la precedncia F>=G per tots els smbols que queden
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set_trivial_int_rules(Crules,Ccycles,LInts,LIntsfix,Prec,Stat,
		CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,PrecOut,StatOut):-
	obtain_superset_ge_no_others(Crules,Ccycles,LInts,LIntsfix,CrulesD,Def,RestCrules),
	Def=[_|_],
	separ_left_noleft(CrulesD,[],PairsLeftRight),
	fix_trivial_interp(Def,PairsLeftRight,LInts,LIntsfix,Prec,Stat,LInts1,LIntsfix1,Prec1,Stat1),!,
	simplify_and_check2(RestCrules,Ccycles,LInts1,LIntsfix1,
			Crules2,Ccycles2,LInts2,LIntsfix2,Prec1,Stat1,Prec2,Stat2),
	set_int_leftisvar2(Crules2,Ccycles2,LInts2,LIntsfix2,
		CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,Prec2,Stat2,PrecOut,StatOut).
set_trivial_int_rules(Crules,Ccycles,LInts,LIntsfix,Prec,Stat,
		Crules,Ccycles,LInts,LIntsfix,Prec,Stat).
	


% CrulesD son regles amb top que no apareix en cap lloc que no sigui CrulesD
% que tenen com a possible interpretaci del top 100..0 
% Def cont els smbols TOP de les regles CrulesD
obtain_superset_ge_no_others(Crules,Ccycles,LInts,LIntsfix,CrulesD,Def,RestCrules):-
	obtain_non_possible_proj_top(LInts,LIntsfix,SnoPossibleTop),
	obtain_noncollapsing_ge_rules(Crules,Crules1,RCrules,[],D1),
	concat312(RCrules,Ccycles,Others),
	get_all_poss_symbolsD(Others,LInts,SnoPossibleTop,Symbs),
	obtain_superset_indep(Crules1,D1,Symbs,LInts,CrulesD,[],NoDRules,Def),
	concat312(RCrules,NoDRules,RestCrules),!.
	

% SnoPossibleTop : smbols que no admeten interpretaci de proj. al top
obtain_non_possible_proj_top(LInts,LIntsfix,SnoPossibleTop):-
	obtain_non_possible_proj_top_LIntsfix(LIntsfix,[],S1),
	obtain_non_possible_proj_top_LInts(LInts,S1,SnoPossibleTop),!.
	

obtain_non_possible_proj_top_LIntsfix(LIntsfix,S,SnoPossibleTop):-
	delete33([F,_,Int],LIntsfix,LIntsfix1),
	((Int=[0|_] )
	 ; 
	 (Int=[1|L], member21(1,L))
	),!,
	obtain_non_possible_proj_top_LIntsfix(LIntsfix1,[F|S],SnoPossibleTop),!.
obtain_non_possible_proj_top_LIntsfix(_,S,S).
		
obtain_non_possible_proj_top_LInts(LInts,S,SnoPossibleTop):-
	delete33([F,Ar,LIntF],LInts,LInts1),
	crearlistNK(Ar,0,L0),
	\+(member21([1|L0],LIntF)),!,
	obtain_non_possible_proj_top_LInts(LInts1,[F|S],SnoPossibleTop),!.
obtain_non_possible_proj_top_LInts(_,S,S).


% retorna LS++tots els smbols 'possibles' de la llista de regles sense repetits.

get_all_poss_symbolsD([],_,LS,LS):-!.
get_all_poss_symbolsD([Rule|Rules],LInts,LS,LSOut):-
	Rule=..[_|LT],
	get_all_poss_symbols(LT,LInts,LS,LS1),
	get_all_poss_symbolsD(Rules,LInts,LS1,LSOut),!.	


get_all_poss_symbols([],_,LS,LS):-!.
get_all_poss_symbols([Term|Terms],LInts,LS,LSOut):-!,
	get_all_poss_symbols(Term,LInts,LS,LS1),
	get_all_poss_symbols(Terms,LInts,LS1,LSOut),!.
get_all_poss_symbols(T,_,LS,LS):-
	is_variable(T),!.
get_all_poss_symbols(T,LInts,LS,LSOut):-
	T=..[F|Args],
	member21([F,_,IntsF],LInts),!,
	args_possibles(Args,IntsF,Args1,'no'),
	((member21([1|_],IntsF),!, addifno(F,LS,LS1))
	 ;
	 (LS1=LS)
	),!,
	get_all_poss_symbols(Args1,LInts,LS1,LSOut),!.
get_all_poss_symbols(T,LInts,LS,LSOut):-
	T=..[F|Args],
	addifno(F,LS,LS1),
	get_all_poss_symbols(Args,LInts,LS1,LSOut),!.

			

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% obtain_noncollapsing_ge_rules(Crules,Crules1,CrulesRest,D,DOut)
% Posa a Crules1 totes les regles L>=R no col.lapsants de Crules
% i a CrulesRest la resta.
% DOut cont tots els smbols TOP de les regles de Crules1. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
obtain_noncollapsing_ge_rules([],[],[],D,D).
obtain_noncollapsing_ge_rules([L>=R|Crules],[L>=R|Crules1],CrulesRest,D,DOut):-
	\+(is_variable(R)),!,   % L segur no variable perque venim de set_int_leftisvar
	functor(L,F,_), functor(R,G,_),
	addifno(F,D,D1), addifno(G,D1,D2),
	obtain_noncollapsing_ge_rules(Crules,Crules1,CrulesRest,D2,DOut).
obtain_noncollapsing_ge_rules([Rule|Crules],Crules1,[Rule|CrulesRest],D,DOut):-
	obtain_noncollapsing_ge_rules(Crules,Crules1,CrulesRest,D,DOut).

%
% Symbs=smbols que no admeten interp. al top o que apareixen en altres regles
% Retorna a CrulesDOut totes les regles independents que admeten interp.
% de proj. al top. DOut cont els smbols. NoDOutRules cont R1++la resta de regles.

obtain_superset_indep(Crules,D,Symbs,LInts,CrulesOut,R1,NoDOutRules,DOut):-
	inter(Symbs,D,SD),
	SD=[_|_],!,
	difer(D,SD,D1),
	separ(Crules,SD,CrulesSD,Crules1),
	get_all_poss_symbolsD(CrulesSD,LInts,[],SymbsSD),	
	union(Symbs,SymbsSD,Symbs1),
	concat312(CrulesSD,R1,R2),	
	obtain_superset_indep(Crules1,D1,Symbs1,LInts,CrulesOut,R2,NoDOutRules,DOut),!.	
obtain_superset_indep(Crules,D,_,_,Crules,R,R,D).

separ([],_,[],[]).
separ([L>=R|Crules],Symbs,CrulesSymbs,[L>=R|OtherRules]):-
	functor(L,F,_),
	functor(R,G,_),
	inter(Symbs,[F,G],[]),!,
	separ(Crules,Symbs,CrulesSymbs,OtherRules),!.
separ([Rule|Crules],Symbs,[Rule|CrulesSymbs],OtherRules):-
	separ(Crules,Symbs,CrulesSymbs,OtherRules),!.

separ_left_noleft([],Pairs,Pairs).
separ_left_noleft([L>=R|CrulesD],Pairs,PairsOut):-
	functor(L,F,_),
	functor(R,G,_),
	((F==G,!,Pairs1=Pairs)
	  ;
	 (addifno([F,G],Pairs,Pairs1))
	),!,
	separ_left_noleft(CrulesD,Pairs1,PairsOut),!.
	

fix_trivial_interp(D,PairsLeftRight,LInts,LIntsfix,Prec,Stat,LIntsOut,LIntsfixOut,PrecOut,StatOut):-
	generar_prec_pairs(PairsLeftRight,Prec,PrecOut,Stat,StatOut),!,
	fix_trivial_interp1(D,LInts,LIntsfix,LIntsOut,LIntsfixOut).	

generar_prec_pairs([],Prec,Prec,Stat,Stat).
generar_prec_pairs([[F,G]|PairsLeftRight],Prec,PrecOut,Stat,StatOut):-
	generarF(F>=G,Prec,Prec1,Stat,Stat1),!,
	generar_prec_pairs(PairsLeftRight,Prec1,PrecOut,Stat1,StatOut).


fix_trivial_interp1([],LInts,LIntsfix,LInts,LIntsfix).
fix_trivial_interp1([D|Def],LInts,LIntsfix,LIntsOut,LIntsfixOut):-
	delete32([D,Ar,_],LInts,LInts1),!,
	crearlistNK(Ar,0,L0),  %segur que [1|L0] es a LIntD- comprovat abans
	fix_trivial_interp1(Def,LInts1,[[D,Ar,[1|L0]]|LIntsfix],LIntsOut,LIntsfixOut),!.
fix_trivial_interp1([_|Def],LInts,LIntsfix,LIntsOut,LIntsfixOut):-  % D ja es a LIntsfix i amb [10...0]
	fix_trivial_interp1(Def,LInts,LIntsfix,LIntsOut,LIntsfixOut),!. % comprovat abans
	
	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

base_rules([],LC,Cc,LC,Cc,LInt,LInt,Lfix,Lfix,Prec,Prec,Stat,Stat).
base_rules([[S,Ar]|RDef],LConst,Const_cycles,LConstOut,Const_cyclesOut,
		LInts,LIntsOut,LIntsfix,LIntsfixOut,Prec,PrecOut,Stat,StatOut):-
	delete32([S,Ar,LIdef],LInts,LIntsrest),
	def_base_rules([S,Ar],LConst,DefConst,Const_cycles),!,
	set_int_prec_def([S,Ar],DefConst,LIdef,Idef,LIntsrest,Prec,Prec1,
			Stat,Stat1),
	apply_intDef([S,Ar],RDef,RDef1,Idef,LConst,LConstI),
	apply_intDef([S,Ar],RDef1,RDef2,Idef,Const_cycles,Const_cyclesI),
	simplify_and_check2(LConstI,Const_cyclesI,LIntsrest,[[S,Ar,Idef]|LIntsfix],
			LConst2,Const_cycles2,LInts2,LIntsfix2,Prec1,Stat1,Prec11,Stat11),
	set_int_leftisvar2(LConst2,Const_cycles2,LInts2,LIntsfix2,
		LConst3,Const_cycles3,LInts3,LIntsfix3,Prec11,Stat11,Prec2,Stat2),
	base_rules(RDef2,LConst3,Const_cycles3,LConstOut,Const_cyclesOut,
			LInts3,LIntsOut,LIntsfix3,LIntsfixOut,Prec2,PrecOut,
			Stat2,StatOut).
base_rules([_|RDef],LConst,Const_cycles,LConstOut,Const_cyclesOut,
		LInts,LIntsOut,LIntsfix,LIntsfixOut,Prec,PrecOut,Stat,StatOut):-
	base_rules(RDef,LConst, Const_cycles,LConstOut,Const_cyclesOut,
		LInts,LIntsOut,LIntsfix,LIntsfixOut,Prec,PrecOut,Stat,StatOut).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% def_base_rules : 
%% col.lapsants, dreta ground constructors, crida recursiva directa
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
def_base_rules(Def,C,DefC,Cc):-
	obtain_def_base_rules(Def,C,DefC,Crest),!,
	check_def_no_left(Def,Crest),
	check_def_no_left(Def,Cc).

obtain_def_base_rules(_,[],[],[]).
obtain_def_base_rules([S,Ar],[C|Rc],[C|Cdef],Crest):-
	C=..[_|[L,R]],L=..[S|_],!,
	noleftR(Const),
	check_right(R,[S,Ar],Const),
	obtain_def_base_rules([S,Ar],Rc,Cdef,Crest).
obtain_def_base_rules(Def,[C|Rc],Cdef,[C|Crest]):-
	obtain_def_base_rules(Def,Rc,Cdef,Crest).


check_right(R,_,_):-is_variable(R),!.
check_right(R,[S,Ar],Const):-R=..[S|Args],!,
		check_argsOk(Args,[[S,Ar]|Const]),!.
check_right(R,_,Const):-check_ground_const(R,Const),!.


check_argsOk([],_):-!.
check_argsOk([S1|R],L):-check_termOk(S1,L),!, check_argsOk(R,L).

check_termOk(S,_):-is_variable(S),!.
check_termOk(S,L):-S=..[F|Args], 
		member22([F,_],L),!, check_argsOk(Args,L).

check_ground_const([],_):-!.
check_ground_const([S|R],L):-!,
		check_ground_const(S,L),!,
		check_ground_const(R,L).
check_ground_const(S,L):-
		S=..[F|Args], member22([F,_],L),!, 
		check_ground_const(Args,L).


check_def_no_left(_,[]):-!.
check_def_no_left(Def,[C|Rest]):- C=..[_|[Left,_]],!,check_noS(Def,Left),!,
			check_def_no_left(Def,Rest).

check_noS(_,[]):-!.
check_noS(Def,[S|Rest]):-!,check_noS(Def,S), check_noS(Def,Rest).
check_noS([S,_],Term):-Term=..[S|_],!,fail.
check_noS(Def,Term):-Term=..[_|Args], check_noS(Def,Args).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ..._fix : per smbols que noms tenen regles colapsants i recursives i una nica
%	possibilitat de selecci d'un subterme(aix no restringim I's). 
%	Provem d'aplicar I i satisfer RPO sense fixar cap restricci de prec ni I's.
%	Noms en cas de quedar-nos el top fixem lex o mul, propagant per =F. 
%	(no back)
% ..._back: ordenem les interpretacions i intentem satisfer el sistema segons aquest
%	ordre. Cas 10...0 fixem precedncies...
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set_int_prec_def([F,Ar],DefConst,LIdef,Idef,_,Prec,Prec,Stat,StatOut):-
	set_int_prec_def_fix([F,Ar],DefConst,LIdef,Idef,Stat,Stat1),
	is_stat_set(F,Stat,Stat1,StatOut,Prec),!.
set_int_prec_def(Def,DefConst,LIdef,Idef,LIntsRest,Prec,Prec1,Stat,Stat1):-
	set_int_prec_def_back(Def,DefConst,LIdef,Idef,LIntsRest,Prec,Prec1,Stat,Stat1).

is_stat_set(F,Stat,Stat1,StatOut,Prec):-
	member21([F,StatF],Stat1),
	\+(member21([F,StatF],Stat)),!,
	close_stat(Prec,Stat1,StatOut,[F,StatF]),!.		
is_stat_set(_,_,Stat,Stat,_):-!.


%% fixem una Interpretaci sense opci a backtracking.
%% noms pels smbols amb regles colapsants o crida recursiva directa.

set_int_prec_def_fix([S,Ar],Const,LIdef,Idef,Stat,Stat1):-
	check_col_or_rec(S,Const,_,Const_rec),
	set_int1(Ar,LIdef,Idef),
	check_rpo13_fix_int(Const_rec,[S,Ar],Idef,Stat,Stat1).

check_col_or_rec(_,[],[],[]):-!.
check_col_or_rec(S,[Const|RestConst],[Const|RC1],RC2):-
	Const=..[_|[_,R]], is_variable(R),!,
	check_col_or_rec(S,RestConst,RC1,RC2).
check_col_or_rec(S,[Const|RestConst],RC1,[Const|RC2]):-
	Const=..[_|[_,R]], R=..[S|_],!,
	check_col_or_rec(S,RestConst,RC1,RC2).

%% ens quedem amb la opci que t mnim nombre de 1's (si noms hi ha una opci)
set_int1(Ar,LIdef,Idef):-min1s(1,Ar,LIdef,Idef).

min1s(N,_,LInts,Int):-setof(Int,sel_N_1s(LInts,N,Int),L),!,L=[Int].
min1s(N,Ar,LInts,Int):- N=<Ar, N1 is N+1,
			min1s(N1,Ar,LInts,Int).

sel_N_1s([Int|_],N,Int):-sum(Int,N).
sel_N_1s([_|RestInts],N,Int):-sel_N_1s(RestInts,N,Int).


%%fixem una Interpretaci amb opci a backtracking.
%% ordenant les interpretacions de ms a menys restrictives.

set_int_prec_def_back(S_Ar,LConst,LIdef,Idef,LIntsRest,Prec,Prec1,Stat,Stat1):-
	ordena_Ints(LIdef,LIord),	
	set_int2(S_Ar,LIord,Idef,LConst,LIntsRest,Prec,Prec1,Stat,Stat1).


ordena_Ints(LInts,[[1|R]|Lord]):-
	delete33([1|R],LInts,LInts1),
	alllist_K(R,0),!,
	sort(LInts1,Lord),!.
ordena_Ints(LInts,Lord):-
	sort(LInts,Lord),!.

set_int2([S,Ar],[Int|_],Int,LConst,LIntsRest,Prec1,Prec2,Stat,Stat1):-
	generar_Int([S,Ar],Int,LConst,LIntsRest,Prec1,Prec2,Stat,Stat1).
set_int2([S,Ar],[_|RestInts],Int,LConst,LIntsRest,Prec1,Prec2,Stat,Stat1):-
	set_int2([S,Ar],RestInts,Int,LConst,LIntsRest,Prec1,Prec2,Stat,Stat1).

generar_Int([S,_],[1|RInt],LConst,_,Prec1,Prec2,Stat1,Stat2):-
	alllist_K(RInt,0),!,
	generar_prec(S,LConst,Prec1,Prec2,Stat1,Stat2).
generar_Int(Sym,Int,LConst,LIntsRest,Prec,Prec,Stat,Stat):-
	check_LConst_Int(Sym,Int,LConst,LIntsRest),!.
	
check_LConst_Int(_,_,[],_):-!.
check_LConst_Int([S,Ar],Int,[Const|RConst],LIntsRest):-
	interp_const(Const,[[S,Ar,Int]],ConstI),
	possible(ConstI,LIntsRest),!,
	check_LConst_Int([S,Ar],Int,RConst,LIntsRest),!.
	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
generar_prec(_,[],P,P,St,St):-!.
generar_prec(S,[C|RestC],Prec1,Prec,Stat1,Stat):-
	generar_prec1(S,C,Prec1,Prec2,Stat1,Stat2),
	generar_prec(S,RestC,Prec2,Prec,Stat2,Stat),!.

generar_prec1(S,C,Prec1,Prec2,Stat1,Stat2):-
	C=..[Op|[_,R]],
	noleftR(Const),
 	check_ground_const(R,Const),!,
	generar_prec1(S,Op,R,Prec1,Prec2,Stat1,Stat2),!.
generar_prec1(_,_,P,P,St,St):-!.

generar_prec1(S,>=,R,Prec1,Prec2,Stat1,Stat2):-
	list_symbols(R,[],[F]),!,
	generarF(S>=F,Prec1,Prec2,Stat1,Stat2),!.
generar_prec1(S,_,R,Prec1,Prec2,Stat1,Stat2):-
	list_symbols(R,[],LSymb),
	generarF_list(S,LSymb,Prec1,Prec2,Stat1,Stat2),!.
	
generarF_list(_,[],P,P,St,St):-!.
generarF_list(S,[F|RestF],Prec1,Prec2,Stat1,Stat2):-
	generarF(S>F,Prec1,Prec11,Stat1,Stat11),!,
	generarF_list(S,RestF,Prec11,Prec2,Stat11,Stat2),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% elimina totes les aparicions dels smbols interpretats per subterme
%% a la precedncia i stat.

elim_symbs_no_exist(LIntsfix,Prec,PrecOut,Stat,StatOut):-
	obtain_symbs_subt(LIntsfix,[],Lsymbs),
	elim_symbs_prec(Lsymbs,Prec,PrecOut),
	elim_symbs_stat(Lsymbs,Stat,StatOut),!.	

obtain_symbs_subt([],L,L):-!.
obtain_symbs_subt([[S,_,[0|_]]|Rest],L,LOut):-
	obtain_symbs_subt(Rest,[S|L],LOut),!.
obtain_symbs_subt([[_,_,[1|_]]|Rest],L,LOut):-
	obtain_symbs_subt(Rest,L,LOut),!.


elim_symbs_prec(_,[],[]):-!.
elim_symbs_prec(Symbs,[P|Prec],PrecOut):-
	P=..[_|[F,G]],
	(member21(F,Symbs);member21(G,Symbs)),!,
	elim_symbs_prec(Symbs,Prec,PrecOut),!.
elim_symbs_prec(Symbs,[P|Prec],[P|PrecOut]):-
	elim_symbs_prec(Symbs,Prec,PrecOut),!.
	
elim_symbs_stat([],Stat,Stat):-!.
elim_symbs_stat([S|R],Stat,StatOut):-
	delete032([S,_],Stat,Stat1),!,
	elim_symbs_stat(R,Stat1,StatOut),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

apply_intDef(_,RDef,RDef,_,[],[]):-!.
apply_intDef([S,Ar],RDef,RDef1,Idef,[Const|RestConst],LConstI):-
	interp_const(Const,[[S,Ar,Idef]],ConstI),!,
	apply_intDef_rest(Const,ConstI,[S,Ar],RDef,RDef1,Idef,RestConst,LConstI),!.

apply_intDef_rest(Const,ConstI,[S,Ar],RDef,RDefOut,[0|Idef],
				RestConst,[ConstI|LConstI]):-
	Const=..[_|[L,R]], R=..[S|_], L=..[F|_],
	\+(F=S),leftR(LDefs),member22([F,A],LDefs),
	addifno([F,A],RDef,RDef1),
	apply_intDef([S,Ar],RDef1,RDefOut,[0|Idef],RestConst,LConstI).

apply_intDef_rest(_,ConstI,[S,Ar],RDef,RDefOut,Idef,
				RestConst,[ConstI|LConstI]):-
	apply_intDef([S,Ar],RDef,RDefOut,Idef,RestConst,LConstI).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	

simplify_and_check2(Crules,Ccycles,LInts,LIntsfix,CrulesOut,CcyclesOut,
				LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut):-
	simplify_Ints(Crules,Ccycles,LInts,LInts1,LIntsfix,
				LIntsfix1,Crules2,Ccycles2),
	concat312(Crules2,Ccycles2,Allconst),
	set_prec_left1symbol_topsegur(Allconst,Allconst,LInts1,LInts2,Prec,Stat,Prec1,Stat1),	
	try_subterm_or_prec_segures(Allconst,Prec1,Prec2,Stat1,Stat2,LInts2),
	check_rules2(Crules2,Ccycles2,LInts2,Crules3,Ccycles3,Prec2,Stat2),
	end_simplify_and_check2(LInts1,LInts2,Prec,Prec2,Crules,Crules3,Ccycles,Ccycles3,
			Stat2, LIntsfix1, CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,
			PrecOut,StatOut),!.


%If there is no change in Prec,LInts,Crules,Ccycles then RETURN.
end_simplify_and_check2(LInts1,LInts2,Prec1,Prec2,Crules1,Crules2,Ccycles1,Ccycles2, Stat2, LIntsfix2, 
			Crules22,Ccycles22,LInts22,LIntsfix2,Prec22,Stat2):-
sort(Prec1,Prec11), sort(Prec2,Prec22), Prec11=Prec22,
sort(LInts1,LInts11), sort(LInts2,LInts22), LInts11=LInts22,
sort(Crules1,Crules11), sort(Crules2,Crules22), Crules11=Crules22,
sort(Ccycles1,Ccycles11), sort(Ccycles2,Ccycles22), Ccycles11=Ccycles22,!.
%If there are changes in Prec or LInts or Crules or Ccycles then simplify_and_check2 again.
end_simplify_and_check2(_,LInts2,_,Prec2,_,Crules2,_,Ccycles2,Stat2,LIntsfix2, 
			CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,PrecOut,StatOut):-
	simplify_and_check2(Crules2,Ccycles2,LInts2,LIntsfix2,CrulesOut,CcyclesOut,
				LIntsOut,LIntsfixOut,Prec2,Stat2,PrecOut,StatOut),!.

%%%
check_rules2(Const_rules,Const_cycles,LInts,Crules,Ccycles,Prec,Stat):-
	check_rules(Const_rules,LInts,Prec,Stat,[],Crules),
	check_rules(Const_cycles,LInts,Prec,Stat,[],Ccycles),!.

%%%%%%

simplify_and_check1(Crules,LInts,LIntsfix,CrulesOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut):-
    	simplify_Ints(Crules,[],LInts,LInts1,LIntsfix,LIntsfix1,Crules2,[]),
	set_prec_left1symbol_topsegur(Crules2,Crules2,LInts1,LInts2,Prec,Stat,Prec1,Stat1),	
	try_subterm_or_prec_segures(Crules2,Prec1,Prec2,Stat1,Stat2,LInts2),
	check_rules(Crules2,LInts2,Prec2,Stat2,[],Crules3),
	end_simplify_and_check1(LInts1,LInts2,Prec,Prec2,Crules,Crules3,
			Stat2, LIntsfix1, CrulesOut,LIntsOut,LIntsfixOut,
			PrecOut,StatOut),!.


%If there is no change in Prec,LInts,Crules then RETURN.
end_simplify_and_check1(LInts1,LInts2,Prec1,Prec2,Crules1,Crules2, Stat2, LIntsfix2, 
			Crules22,LInts22,LIntsfix2,Prec22,Stat2):-
	sort(Prec1,Prec11), sort(Prec2,Prec22), Prec11=Prec22,
	sort(LInts1,LInts11), sort(LInts2,LInts22), LInts11=LInts22,
	sort(Crules1,Crules11), sort(Crules2,Crules22), Crules11=Crules22,!.
%If there are changes in Prec or LInts or Crules then simplify_and_check1 again.
end_simplify_and_check1(_,LInts2,_,Prec2,_,Crules2,Stat2,LIntsfix2, 
			CrulesOut,LIntsOut,LIntsfixOut,PrecOut,StatOut):-
	simplify_and_check1(Crules2,LInts2,LIntsfix2,CrulesOut,
				LIntsOut,LIntsfixOut,Prec2,Stat2,PrecOut,StatOut),!.




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% . es fixen interpretacions amb opci a BACKTRACKING per regles amb 
% part esquerra VARIABLE --> x>=Terme ///

	
set_int_leftisvar2(Crules,Ccycles,LInts,LIntsfix,
   CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut):-
	delete33(Rule,Crules,Crules0),
	Rule=..[>=|[L,R]], is_variable(L),!,
	leftisvar_fix_right(L,R,LInts,Isymbs,LInts1),
	interpret(Crules0,Isymbs,[],Crules1),
	interpret(Ccycles,Isymbs,[],Ccycles1),
	concat312(Isymbs,LIntsfix,LIntsfix1),
	simplify_and_check2(Crules1,Ccycles1,LInts1,LIntsfix1,
		Crules2,Ccycles2,LInts2,LIntsfix2,Prec,Stat,Prec1,Stat1),
	set_int_leftisvar2(Crules2,Ccycles2,LInts2,LIntsfix2,
		CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,Prec1,Stat1,PrecOut,StatOut).
set_int_leftisvar2(Crules,Ccycles,LInts,LIntsfix,
			Crules,Ccycles,LInts,LIntsfix,P,S,P,S).
	
leftisvar_fix_right(Var,R,LInts,LIsymbs,LIntsOut):-
	obtain_posic_var(Var,R,Lcamins,LInts),!,
	member22(Cami,Lcamins),
	establir_int_cami(Cami,LInts,[],LIsymbs,LIntsOut).

establir_int_cami([],LInts,LIsymbs,LIsymbs,LInts):-!.
establir_int_cami([[F,P]|Cami],LInts,LIsymbs,LIsymbsOut,LIntsOut):-
	delete32([F,Ar,LIntsF],LInts,LInts1),
	crearlistNK(P,0,L1), 
	N is Ar-P, crearlistNK(N,0,L2), concat312(L1,[1|L2],L),
	member21(L,LIntsF),!,
	establir_int_cami(Cami,LInts1,[[F,Ar,L]|LIsymbs],LIsymbsOut,LIntsOut),!.
		

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set_int_leftisvar1(Crules,LInts,LIntsfix,CrulesOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut):-
	delete33(Rule,Crules,Crules0),
	Rule=..[>=|[L,R]], is_variable(L),!,
	leftisvar_fix_right(L,R,LInts,Isymbs,LInts1),
	interpret(Crules0,Isymbs,[],Crules1),
	concat312(Isymbs,LIntsfix,LIntsfix1),
	simplify_and_check1(Crules1,LInts1,LIntsfix1,Crules2,LInts2,LIntsfix2,Prec,Stat,Prec1,Stat1),
	set_int_leftisvar1(Crules2,LInts2,LIntsfix2,CrulesOut,LIntsOut,LIntsfixOut,Prec1,Stat1,PrecOut,StatOut).
set_int_leftisvar1(Crules,LInts,LIntsfix,Crules,LInts,LIntsfix,P,S,P,S).	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Fixa precedncia en : agafant els subtermes possibles del terme esquerra queda
%    quan f>g(...) i f i g top segur --> f>g
%    quan f>=g(...) i f i g top segur --> f>=g
%    quan f(vars) (> o >=) g(...)  i f i g top segur --> f>=g
%    quan f(s_i) (> o >=) g(...)  i f i g top segur amb g>f --> 
%		generar simplificacions d'interpretacions i generar precedencies
%		considerant s_i>= g(...) 
 

set_prec_left1symbol_topsegur([],_,L,L,Prec,Stat,Prec,Stat):-!.
set_prec_left1symbol_topsegur([Rule|Crules],Allrules,LInts,LIntsOut,Prec,Stat,PrecOut,StatOut):-
	Rule=..[Op|[L,R]],\+(is_variable(L)),\+(is_variable(R)),
	R=..[G|_], top_segur(G,LInts),!,
	L=..[F|Args],
	sel_args_possibles(F,Args,LInts,A),
	act_prec_A(Op,F,G,R,A,Allrules,Prec,Stat,Prec1,Stat1,LInts,LInts1),
	set_prec_left1symbol_topsegur(Crules,Allrules,LInts1,LIntsOut,Prec1,Stat1,PrecOut,StatOut),!.
set_prec_left1symbol_topsegur([_|Crules],Allrules,LInts,LIntsOut,Prec,Stat,PrecOut,StatOut):-
	set_prec_left1symbol_topsegur(Crules,Allrules,LInts,LIntsOut,Prec,Stat,PrecOut,StatOut),!.

act_prec_A(Op,F,G,_,A,_,Prec,Stat,PrecOut,StatOut,LInts,LInts):-
	(A=[];all_variables(A)),!,
	((Op='>',A=[],!,generarF(F>G,Prec,PrecOut,Stat,StatOut)) ;
	  generarF(F>=G,Prec,PrecOut,Stat,StatOut)
	),!.
act_prec_A(_,F,G,R,[Sub],Allrules,Prec,Stat,PrecOut,StatOut,LInts,LIntsOut):-
	member212(G>F,Prec),!,
	simplify_Ints_vars_Sat([Sub>=R|Allrules],LInts,LInts1),
	set_prec_left1symbol_topsegur([Sub>=R],Allrules,LInts1,LIntsOut,Prec,Stat,PrecOut,StatOut),!.
act_prec_A(_,_,_,_,_,_,Prec,Stat,Prec,Stat,LInts,LInts).


sel_args_possibles(F,Args,LInts,A):-
	member22([F,_,LIntsF],LInts),!,
	args_possibles(Args,LIntsF,A,'no'),!.
sel_args_possibles(_,A,_,A).
		
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%check_rules : simplifica per subterme sota posici segura
%%	      comprova possible per variables en pos. segura 
%%		Noms es consideren regles >= o >. 
%%		(dins rpo s que tindrem =).

check_rules([],_,_,_,L,L):-!.
check_rules([Rule|_],_,_,_,_,_):-
	Rule=..[>|[L,_]],
	is_variable(L),!,fail.
check_rules([Rule|_],LInts,_,_,_,_):-
	Rule=..[Op|[L,R]], compl_Op(Op,Op1),
	Rule2=..[Op1|[R,L]],
	trivial(Rule2,LInts),!,fail.
check_rules([Rule|LRules],LInts,Prec,Stat,LRules0,LRulesOut):-
	trivial(Rule,LInts),!,
	check_rules(LRules,LInts,Prec,Stat,LRules0,LRulesOut),!.
check_rules([Rule|_],_,_,_,_,_):-
	Rule=..[>=|[L,R]],
	is_variable(L),
	\+(member_term1(L,R)),!,fail.   %la interpretaci es fixar al fer check_vars_left.
check_rules([Rule|LRules],LInts,Prec,Stat,LRules0,LRulesOut):-
        Rule=..[Op|[L,R]],
	interpretat(R,LInts),!,
	tryRinterp(Op,L,R,LInts,Prec,Stat,Rules0,LRules0,LRules00),
	concat312(Rules0,LRules,LRules1),
	check_rules(LRules1,LInts,Prec,Stat,LRules00,LRulesOut),!.
check_rules([Rule|LRules],LInts,Prec,Stat,LRules0,LRulesOut):-
	Rule=..[Op|[L,R]], L=..[F|ArgsL], R=..[G|ArgsR], 
	\+(member212([F,_,_],LInts)),
	\+(member212([G,_,_],LInts)),
	igual(F,G,Prec),
	quin_stat(F,Stat,StatF),
	difer_args_Int(StatF,ArgsL,ArgsR,[],DifRL,LInts),!,
	Op='>=', DifRL=[],!,
	check_rules(LRules,LInts,Prec,Stat,[Rule|LRules0],LRulesOut),!.
check_rules([Rule|LRules],LInts,Prec,Stat,LRules0,LRulesOut):-
	possible(Rule,LInts),!,
	check_rules(LRules,LInts,Prec,Stat,[Rule|LRules0],LRulesOut),!.

compl_Op('>','>=').
compl_Op('>=','>').


%
trivial(L>=R,LInts):-
	L=..[F|ArgsL],
	R=..[F|ArgsR],
	pos_impos(F,LInts,Limpos),
	args_pos_poss(ArgsL,Limpos,A1),
	args_pos_poss(ArgsR,Limpos,A2),	
	all_args_included(A1,A2,LInts),!.	
trivial(L>=R,LInts):-!,
	en_pos_segura_Int(L,R,LInts).
trivial(L>R,LInts):-    
	strict_subt_segura(L,R,LInts),!.


all_args_included([],[],_):-!.
all_args_included([X|A],[Y|B],LInts):-
	en_pos_segura_Int(X,Y,LInts),
	all_args_included(A,B,LInts),!.

%%%%%%%%%%%%%%%%

interpretat(Term,LInts):-
	list_symbols(Term,[],Symbs),
	notappear(Symbs,LInts),!.

notappear([],_):-!.
notappear([F|_],LInts):-
	member22([F,_,_],LInts),!,fail.
notappear([_|Rest],LInts):-
	notappear(Rest,LInts),!.


%mira si es pot eliminar la regla o es pot simplificar fent L>subtR o si possible
% si falla s que no pot ser L op R amb rpo
% 
tryRinterp(Op,L,R,LInts,Prec,Stat,NewR,LRules,LRulesOut):-
	interpretat(L,LInts),!,
	Rule=..[Op|[L,R]],
	check_rules_rpo([Rule],Prec,Stat,[],ROut),!,
	simplified_or_top(ROut,Prec,ROut2,NewR),
	concat312(ROut2,LRules,LRulesOut).	
tryRinterp(_,L,R,LInts,Prec,_,ROut,LRules,LRules):-
	functor(L,F,_), 
	top_segur(F,LInts),
	R=..[G|ArgsR],
	member22(F>G,Prec),!,
	gen_rules_rec_call('>',L,ArgsR,[],ROut),!.
tryRinterp(Op,L,R,LInts,_,_,[],LRules,[Rule|LRules]):-
	Rule=..[Op|[L,R]],
	possible(Rule,LInts).


simplified_or_top([],_,[],[]):-!.
simplified_or_top([Rule],Prec,[],NewRules):-
	Rule=..[_|[L,R]],
	functor(L,F,_), R=..[G|ArgsR],
	member22(F>G,Prec),!,
	gen_rules_rec_call('>',L,ArgsR,[],NewRules),!.
simplified_or_top(R,_,R,[]).


%%%%%%%%%%%%%%%%

possible(ConstI,_):- ConstI=..[>|[L,L]],!,fail.
possible(ConstI,LInts):-
	ConstI=..[_|[Left,Right]],
	is_variable(Left),!,
	possible_int_right(Left,Right,LInts).
possible(ConstI,LInts):- 
	ConstI=..[_|[Left,Right]],
	vars_segures(Right,[],LvarsR,LInts),
	contains(Left,LvarsR).


possible_int_right(Var,Var,_):-!.
possible_int_right(Var,Term,LInts):-
	member_term_igInt(Var,Term,LInts),
	Term=..[F|Args],
	delete32([F,Ar,IntsF],LInts,LInts1),
	member22([0|R],IntsF),
	selecc_sub_int(R,Args,[Arg],[[F,Ar,[0|R]]]),
	possible_int_right(Var,Arg,LInts1).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

interpret([],_,L,L1):-!,del_repes(L,L1).
interpret([Const|RConst],Isymbs,LConstInt,LConstIntOut):-
	interp_const(Const,Isymbs,ConstI),
	interpret(RConst,Isymbs,[ConstI|LConstInt],LConstIntOut),!.


interp_const(Const,Isymb,C):-
	Const=..[Op|[L,R]],
	interp_term(L,Isymb,L1),
	interp_term(R,Isymb,R1),
	C=..[Op|[L1,R1]],!.

interp_term(Term,Isymb,Term1):-
	Term=..[F|Args],
	member22([F,_,[1|R]],Isymb),!,
	selecc_sub_int(R,Args,Args1,Isymb),
	Term1=..[F|Args1],!.

interp_term(Term,Isymb,Term1):-
	Term=..[F|Args],
	member22([F,_,[0|R]],Isymb),!,
	selecc_sub_int(R,Args,Args1,Isymb),
	Args1=[Term1],!.

interp_term(Term,Isymb,Term1):-
	Term=..[F|Args],	%F not in the set Isymb
	interp_terms(Args,Isymb,Args1),
	Term1=..[F|Args1],!.

interp_terms([],_,[]):-!.
interp_terms([T|RestT],Isymb,[T1|RestT1]):-
	interp_term(T,Isymb,T1),
	interp_terms(RestT,Isymb,RestT1),!.


selecc_sub_int([],[],[],_):-!.
selecc_sub_int([1|R],[X|L],[Y|L1],Isymb):-
	interp_term(X,Isymb,Y),
	selecc_sub_int(R,L,L1,Isymb),!.
selecc_sub_int([0|R],[_|L],L1,Isymb):-
	selecc_sub_int(R,L,L1,Isymb),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% primer es fixen les interpretacions pels smbols definits
% es trien primer els smbols que tenen menys opcions

fix_interp(LInts,LIntsfix,LIntsfixOut,Crules,CrulesOut,
						Prec,Stat,PrecOut,StatOut):-
	fix_interp(LInts,[],LIntsfix,LIntsfixOut,Crules,CrulesOut,
						Prec,Stat,PrecOut,StatOut).

fix_interp([],[],LIntsfix,LIntsfix,Crules,Crules,P,S,P,S).
fix_interp(LInts,LIntsOut,LIntsfix,LIntsfixOut,Crules,CrulesOut,
						Prec,Stat,PrecOut,StatOut):-
	LInts=[_|_],
	obtain_Def_min_opts(LInts,[F,Ar,LIntsF],LInts1),!,
 	fix_interp1([F,Ar,LIntsF],LInts1,LInts2,LIntsfix,LIntsfix1,Crules,Crules1,
			Prec,Prec1,Stat,Stat1),
	fix_interp(LInts2,LIntsOut,LIntsfix1,LIntsfixOut,Crules1,CrulesOut,
			Prec1,Stat1,PrecOut,StatOut).
fix_interp(LInts,LIntsOut,LIntsfix,LIntsfixOut,Crules,CrulesOut,
						Prec,Stat,PrecOut,StatOut):-
	LInts=[_|_],
	obtain_min_opts(LInts,[F,Ar,LIntsF],LInts1),!,
	((exists_symbRules(Crules,F),!,
	  fix_interp1([F,Ar,LIntsF],LInts1,LInts2,LIntsfix,LIntsfix1,Crules,Crules1,
			Prec,Prec1,Stat,Stat1),
	  fix_interp(LInts2,LIntsOut,LIntsfix1,LIntsfixOut,Crules1,CrulesOut,
			Prec1,Stat1,PrecOut,StatOut))
	 ;
	  fix_interp(LInts1,LIntsOut,LIntsfix,LIntsfixOut,Crules,CrulesOut,
			Prec,Stat,PrecOut,StatOut)
	).
		
%%%%%
fix_interp1([F,Ar,LIntsF],LInts,LIntsOut,LIntsfix,LIntsfixOut,Crules,CrulesOut,
			Prec,PrecOut,Stat,StatOut):-
	member22(IntF,LIntsF),
	interpret(Crules,[[F,Ar,IntF]],[],Crules1),
	simplify_and_check1(Crules1,LInts,[[F,Ar,IntF]|LIntsfix],
			    Crules2,LInts2,LIntsfix2,Prec,Stat,Prec0,Stat0),
	set_int_leftisvar1(Crules2,LInts2,LIntsfix2,Crules3,LInts3,LIntsfix3,
			   Prec0,Stat0,Prec1,Stat1),
	simplify_vars_rhs(Crules3,LInts3,LIntsOut,LIntsfix3,LIntsfixOut,CrulesOut,
			  Prec1,Stat1,PrecOut,StatOut).
			
%%%%%
obtain_Def_min_opts(LInts,Fsel,LIntsOut):-
	leftR(Def),
	obt_Ints_def(Def,LInts,LIntsDef,LInts1),!,
	LIntsDef=[_|_],
	obtain_min_opts(LIntsDef,Fsel,LInts2),
	concat312(LInts1,LInts2,LIntsOut).


obt_Ints_def(_,[],[],[]):-!.
obt_Ints_def(Def,[[F,Ar,L]|LInts],[[F,Ar,L]|LIntsDef],LIntsRest):-
	member22([F,Ar],Def),!,
	obt_Ints_def(Def,LInts,LIntsDef,LIntsRest).
obt_Ints_def(Def,[[F,Ar,L]|LInts],LIntsDef,[[F,Ar,L]|LIntsRest]):-
	obt_Ints_def(Def,LInts,LIntsDef,LIntsRest).



obtain_min_opts([[F,Ar,LIntsF]|LInts],IntOut,LIntsOut):-
	length21(LIntsF,N),
	obtain_min_opts1(LInts,[F,Ar,LIntsF],N,IntOut,LIntsOut),!.

obtain_min_opts1([],Int,_,Int,[]):-!.
obtain_min_opts1([Int1|RInts],Int,N,IntOut,[Int|RIntsOut]):-
	Int1=[_,_,LIntsF],
	length21(LIntsF,M), N>M,!,
	obtain_min_opts1(RInts,Int1,M,IntOut,RIntsOut),!.
obtain_min_opts1([Int1|RInts],Int,N,IntOut,[Int1|RIntsOut]):-
	obtain_min_opts1(RInts,Int,N,IntOut,RIntsOut),!.

	
%%%%%	

exists_symbRules([Rule|_],F):-Rule=..[_|[L,R]],
	(exists_symb_in_Term(F,L) ;exists_symb_in_Term(F,R) ),!.
exists_symbRules([_|Rules],F):-	exists_symbRules(Rules,F),!.

exists_symb_in_Term(_,Term):-
	is_variable(Term),!,fail.
exists_symb_in_Term(F,Term):-
	Term=..[F|_],!.
exists_symb_in_Term(F,Term):-
	Term=..[_|Args],
	exists_symb_in_Term_list(F,Args),!.

exists_symb_in_Term_list(F,[A|_]):-
	exists_symb_in_Term(F,A),!.
exists_symb_in_Term_list(F,[_|Args]):-
	exists_symb_in_Term_list(F,Args),!.

	

