%--------------------------------------------------------
% list.pl: funcions generals de llistes  i termes 
%--------------------------------------------------------
member22(X,[X|_]).
member22(X,[_|L]):- member22(X,L).

member21(X,[Y|_]):-X=Y,!.
member21(X,[_|L]):- member21(X,L).

member212(X,[Y|_]):-X==Y,!.
member212(X,[_|L]):-member212(X,L),!.

concat33([],L,L).
concat33([X|L1],L2,[X|L3]):- concat33(L1,L2,L3).

concat312([],L,L):- !.
concat312([X|L1],L2,[X|L3]):- concat312(L1,L2,L3),!.

%retorna el primer idntic
delete312(X,[Y|L],L):-X==Y,!.
delete312(X,[Y|L],[Y|L1]):- delete312(X,L,L1).

%retorna la llista menys X (primer idntic)
delete0312(_,[],[]):-!.
delete0312(X,[Y|L],L):-X==Y,!.
delete0312(X,[Y|L],[Y|L1]):- delete0312(X,L,L1).

%retorna el primer que unifica i no s resatisfactible.
delete32(X,[X|L],L):-!.
delete32(X,[Y|L],[Y|L1]):- delete32(X,L,L1).

%retorna la llista menys X (primer que unifica)
delete032(_,[],[]):-!.
delete032(X,[X|L],L):-!.
delete032(X,[Y|L],[Y|L1]):- delete032(X,L,L1).

%retorna un que unifiqui.
delete33(X,[X|L],L).
delete33(X,[Y|L],[Y|L1]):- delete33(X,L,L1).

subset33([],L,L).
subset33([X|L1],L2,[X|L3]):- subset33(L1,L2,L3).
subset33(L1,[X|L2],[X|L3]):- subset33(L1,L2,L3).

reverse1(L,L1):-reverse1(L,[],L1).
reverse1([],L,L):-!.
reverse1([X|R],L,R1):-reverse1(R,[X|L],R1),!.

addifno(X,R,R):-member22(X,R),!.
addifno(X,R,[X|R]).

addifno1(X,R,R):-member212(X,R),!.
addifno1(X,R,[X|R]).

difer(L,[],L1):-!,L1=L.
difer(L,[X|R],L1):-delete312(X,L,L11),!, difer(L11,R,L1),!.
difer(L,[_|R],L1):-difer(L,R,L1),!.

difer2(L1,L2,L12,L21):-inter(L1,L2,L),
			difer(L1,L,L12),
			difer(L2,L,L21),!.

inter(_,[],L):-!,L=[].
inter([],_,L):-!,L=[].
inter([X|L1],L2,L3):-delete312(X,L2,L22),!,inter(L1,L22,L),L3=[X|L],!.
inter([_|L1],L2,L):- inter(L1,L2,L),!.

del_repes([],[]):-!.
del_repes([X|R],R1):-
	member212(X,R),!,
	del_repes(R,R1),!.
del_repes([X|R],[X|R1]):-
	del_repes(R,R1),!.


length21(L,N):-long(L,0,N).

long([],N,M):-!,N=M.
long([_|R],N,M):- N1 is N+1, long(R,N1,M).

quants([],[]):-!.
quants([X|R],[[N,X]|RN]):-
	quants1(X,1,R,RnX,N),!,
	quants(RnX,RN),!.

quants1(_,N,[],[],M):-!,N=M.
quants1(X,N,[X|R],R1,M):-!,
	N1 is N+1,
	quants1(X,N1,R,R1,M),!.
quants1(X,N,[Y|R],[Y|R1],M):-!,
	quants1(X,N,R,R1,M),!.


write_list_enum(T,L):-
	write_list_enum(1,T,L).

write_list_enum(_,_,[]).
write_list_enum(K,T,[M|L]):-tab(T),write(K),write(': '),write(M),nl,
			    K1 is K+1, write_list_enum(K1,T,L).

write_list(_,[]).
write_list(T,[M|L]):-tab(T),write(M),nl,write_list(T,L).

write_list([]).
write_list([M|L]):-write(M),nl,write_list(L).

unio1([],L,L1):-!, L1=L.
unio1([X|R],L,L1):-addifno(X,L,L0), unio1(R,L0,L1),!.


union([],L,L1):-!, sort(L,L1),!.
union([X|R],L,L1):-addifno(X,L,L0), union(R,L0,L1),!.

l_union(L_list,L):-
	l_union(L_list,[],L),!.
l_union([],L,L):-!.
l_union([L|Rest],L1,LOut):-union(L,L1,L2), l_union(Rest,L2,LOut),!.

l_concat(L_list,L):-
	l_concat(L_list,[],L),!.
l_concat([],L,L):-!.
l_concat([L|Rest],L1,LOut):-concat312(L,L1,L2), l_concat(Rest,L2,LOut),!.

sum(L,N):-sum(L,0,N),!.
sum([],N,N1):-!,N=N1.
sum([X|R],N,T):-N1 is N+X, sum(R,N1,T),!.

islist([]):-!.
islist([_|_]):-!.

cons(X,L,[X|L]).

head([X|_],X).
tail([_|R],R).

last([X],X):-!.
last([_|R],X):-last(R,X),!.

snd2([_,Y],Y).

thd3([_,_,Z],Z).

head2([X,Y|_],[X,Y]):-!.

map(_,[],[]):-!.
map(Que,[X|R],[XOut|ROut]):-S=..[Que|[X,XOut]], call(S), map(Que,R,ROut),!.

map(_,_,[],[]):-!.
map(Que,P,[X|R],[XOut|ROut]):-S=..[Que|[P,X,XOut]], call(S), map(Que,P,R,ROut),!.

zip(_,[],_,[]):-!.
zip(_,_,[],[]):-!.
zip(Que,[X|R1],[Y|R2],[U|R]):-S=..[Que|[X,Y,U]],call(S), zip(Que,R1,R2,R),!.

list1(X,[X]):-!.

list2(X,Y,[X,Y]):-!.

max_list([X|L],Y):-
	max_list(L,X,Y),!.

max_list([],M,M):-!.
max_list([X|L],M,Max):-
	X>M,!,
	max_list(L,X,Max).
max_list([_|L],M,Max):-
	max_list(L,M,Max).

afegir([],_,[]):-!.
afegir([L|R],K,[[K|L]|R1]):-afegir(R,K,R1),!.

crearlistNK(N,K,L):-afegirlistNK(N,K,[],L).
afegirlistNK(0,_,L,L):-!.
afegirlistNK(N,K,L1,L):-M is N-1,!, afegirlistNK(M,K,[K|L1],L),!.

crearlistIN(I,N,L):-afegirlistIN(I,N,[],L).
afegirlistIN(I,I,L,R):-reverse1([I|L],R),!.
afegirlistIN(I,N,L1,L):-I<N, I1 is I+1,!, 
			afegirlistIN(I1,N,[I|L1],L),!.


enumerate_cons(L,Len):-enumerate_cons(L,1,Len).
enumerate_cons([],_,[]).
enumerate_cons([X|R],N,[[N|X]|R1]):-M is N+1, enumerate_cons(R,M,R1).

enumerate(L,Len):-enumerate(L,1,Len).
enumerate([],_,[]).
enumerate([X|R],N,[[N,X]|R1]):-M is N+1, enumerate(R,M,R1).

enumerate0(X,X1):-enumerate(X,0,X1).

elem(N,L,X):-
	enumerate(L,Len),
	member21([N,X],Len),!.

selec_elems(Nums,L,LOut):-
	enumerate(L,Lenum),
	sel_elems(Nums,Lenum,LOut),!.

sel_elems([],_,[]):-!.
sel_elems([N|Nums],L,[E|LOut]):-
	member21([N,E],L),!,
	sel_elems(Nums,L,LOut).

alllist_K([],_):-!.
alllist_K([K|R],K):-alllist_K(R,K),!.

sort_len(L,LOut):-
	map(length21,L,Llen),
	zip(list2,Llen,L,L1),
	sort(L1,L2),
	map(snd2,L2,LOut),!.

separar_1_2([],[],[]):-!.
separar_1_2([[A,B]|R],[A|R1],[B|R2]):-
	separar_1_2(R,R1,R2),!.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  funcions generals de termes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% member_term1(X,T) comprova si X s subterme de T per X i T ground.
member_term1(X,X):-!.
member_term1(X,T):-T=..[_|Args],member_term1_list(X,Args).

member_term1_list(X,[T|_]):-member_term1(X,T),!.
member_term1_list(X,[_|R]):-member_term1_list(X,R),!.


contains(_,[]):-!.
contains(Term,[X|R]):-member_term1(X,Term),contains(Term,R),!.

% member_term2(X,T) comprova si X s subterme de T per X i T no-ground.


member_term2(X,Y):-var(Y),!,X==Y.
member_term2(X,T):-var(X),!,T=..[_|Args],member_term2_list(X,Args).
member_term2(S,T):-S==T,!.
member_term2(S,T):-T=..[_|Args],member_term2_list(S,Args).

member_term2_list(S,[T|_]):-member_term2(S,T),!.
member_term2_list(S,[_|R]):-member_term2_list(S,R),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

occurs_chk1(X,Y):-var(X),!,X==Y.
occurs_chk1(T,X):-T=..[_|Args],occurs_chk1_list(Args,X).

occurs_chk1_list([T|_],X):-occurs_chk1(T,X),!.
occurs_chk1_list([_|R],X):-occurs_chk1_list(R,X),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% altres funcions generals
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% per X,Y ground i Z var
menor(X,Y,X):-Y>=X,!.
menor(_,Y,Y).



