termptation:- 
	seen,
  % obtaining the input file	
 	nl,nl,nl,nl,nl,nl,
	write('Input File: '), 
	obtainNameFile(F),nl, 
	openFileRules(F),
        read_input_file(Rules,FOut,Inner,Prover,Lex,Depth),
        seen, 
	convert_rules_list(Rules,LRules),
  % obtaining non-given parameters
	obtainParams(FOut,Inner,Prover,Lex,Depth,I,L,D,FileOut),
	perform_status(I,L,D),
	perform_prover_0(Prover,FileOut,LRules),!,
        nl,nl,nl,
        write('Do you want to use the system again [yes]/no: '),
        obtain_answer1(More,y),nl,
        again(More),!.
termptation:-
        nl,nl,nl,
        write('Do you want to use the system again [yes]/no: '),
        obtain_answer1(More,y),nl,
        again(More),!.

term:-  termptation,!.


again('y'):-termptation.
again(_):-halt.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
openFileRules(F):-
	on_exception(_,see(F),openFileRules_error(F)),!.

openFileRules_error(''):-
	write('File Error: Input File is required.'),
        nl,seen,!,fail.
openFileRules_error(F):-
	write('File Error: Cannot open  '),
        write(F),nl,seen,!,fail.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

read_input_file(Rules,FOut,Inner,Prover,Lex,Depth):-
	on_exception(_,read(R),readRules_error),
	analize_read(R,FirstRule,FOut,Inner,Prover,Lex,Depth),
	!,continue(FirstRule,R,Rules,FOut,Inner,Prover,Lex,Depth),!.
read_input_file(_,_,_,_,_,_):-
	write('Error in the input file.'),nl,seen,!,fail.


continue(FirstRule,R,Rules,_,_,_,_,_):-
	FirstRule=='y',!, read_rules(R,Rules),!.
continue(_,_,Rules,FOut,Inner,Prover,Lex,Depth):-
	read_input_file(Rules,FOut,Inner,Prover,Lex,Depth),!.


analize_read(depth,_,_,_,_,_,D):-!,D=y.
analize_read(deeper,_,_,_,_,_,D):-!,D=y.
analize_read(nodepth,_,_,_,_,_,D):-!,D=n.  
analize_read(nodeeper,_,_,_,_,_,D):-!,D=n.  
analize_read(inner,_,_,I,_,_,_):-!,I=y.
analize_read(innermost,_,_,I,_,_,_):-!,I=y.
analize_read(standard,_,_,I,_,_,_):-!,I=n.
analize_read(special,_,_,_,_,S,_):-!,S=y.
analize_read(nospecial,_,_,_,_,S,_):-!,S=n.
analize_read(outfile(F),_,OF,_,_,_,_):-!,OF=F.
analize_read(prover(N),_,_,_,P,_,_):-!,member212(N,[1,2,3,4,5]),P=N.
analize_read(_,y,_,_,_,_,_).


read_rules('end_of_file', []):-!.
read_rules(R, [R|Rules]):-
	on_exception(_,read(R1),readRules_error),
        read_rules(R1, Rules), !.

readRules_error:-
	write('Syntax error in the input file'),seen,nl,nl,!,fail.

convert_rules_list([],[]).
convert_rules_list([Rule|Rest],[[L,R]|Rest1]):-
	Rule=..[->|[L,R]],!,
	convert_rules_list(Rest,Rest1).
convert_rules_list([Rule|_],_):-
	write('Syntax error in the rule: '),nl,
	write(Rule),nl,
	write('It is not a correct rule according to the format.'),
        !,fail.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

obtainParams(FOut,Inner,Prover,Lex,Depth,I,L,D,FileOut):-
	obtainFOut(FOut,FileOut),
	obtainRestParams(Inner,Prover,Lex,Depth,I,L,D),!.


obtainFOut(FOut,FOut):-
	FOut=='',!.
obtainFOut(FOut,FileOut):-
	nonvar(FOut), !,
	((name(FOut,F0),!);
	 (nl,write('File Error: the name of the output file is not correct.'),nl,!,fail)
	),
	concat312(F0,".out",F), name(FileOut,F),
	on_exception(_,tell(FileOut),openOutFile_error(FileOut)), told,!.
obtainFOut(FOut,FileOut):-
	write('Output File [.out](type INTRO if screen) : '), 
	obtainNameFile(FOut),nl,!,
        ( (FOut='',!,FileOut=FOut)
	 ;
	 (\+FOut='', 
	name(FOut,F0),concat312(F0,".out",F), name(FileOut,F),
	 on_exception(_,tell(FileOut),openOutFile_error(FileOut)), told)),!.


openOutFile_error(F):-
	write('File Error: Cannot open  '),
        write(F),nl,
        write('There might be a problem with the path.'),told,!,fail.

obtainRestParams(Inner,Prover,Lex,Depth,Inner,Lex,Depth):-
        nonvar(Inner),nonvar(Prover),nonvar(Lex),nonvar(Depth),!.	 
obtainRestParams(_,P,_,_,n,n,n):-P==5,!.
obtainRestParams(Inner,Prover,Lex,Depth,I,L,D):-
	possible_default(Inner,Prover,Lex,Depth),!,	
	write('The default option is :'),nl,
	write('     Prover 1 (default)'),nl, 	
	write('     Standard rewriting (non-innermost)'),nl,	
	write('     Non-special treatment of arguments'),nl,
	write('     No deeper analysis'),nl,nl,
	write('Do you want to use the default option [yes]/no: '),
	obtain_answer1(Default,y),nl,
   	ask_rest(Default,Prover,Inner,Lex,Depth,I,L,D),!.
obtainRestParams(Inner,Prover,Lex,Depth,I,L,D):-
   	ask_rest(n,Prover,Inner,Lex,Depth,I,L,D),!.


possible_default(Inner,Prover,Lex,Depth):-
	(var(Inner);Inner==n),
	(var(Prover);Prover==1),
	(var(Depth);Depth==n),
	(var(Lex);Lex==n),!.
		

ask_rest('y',1,_,_,_,n,n,n):-!.
ask_rest('n',Prover,Inner,Lex,Depth,I,L,D):-
	obtain_prover(Prover),
	ask_rest_rest(Prover,Inner,Lex,Depth,I,L,D).

obtain_prover(Prover):-nonvar(Prover),!.
obtain_prover(Prover):-
	write('Choose a prover:' ),nl,
	write('1. Default'),nl,
	write('2. Large size rules'),nl,
	write('3. Large number of rules'),nl,
	write('4. Large size and large number of rules'),nl,
	write('5. Recursive Path Ordering'),nl,
	write('prover [1..5]: '),
	obtain_num_prover(Prover,1),nl,nl,!.

obtain_num_prover(Prover1,Default):-
	readWord(Prover),
	((Prover='', Prover1=Default);
	 (\+Prover='',member212(Prover,[1,2,3,4,5]),Prover1=Prover)
	),!.
obtain_num_prover(Prover,Default):-
	write('Please enter a number in [1..5]: '),
	obtain_num_prover(Prover,Default),!.	


ask_rest_rest(5,_,_,_,n,n,n):-!.
ask_rest_rest(_,Inner,Lex,Depth,I,L,D):-
	obtain_inner(Inner,I),
	obtain_special(Lex,L),
%	obtain_depth(I,Depth,D),!.
	obtain_depth(Depth,D),!.

obtain_inner(Inner,I):-
	var(Inner),!,
	write('Innermost ? [no]/yes: '),
	obtain_answer1(I,n),nl,!.
obtain_inner(I,I).

obtain_special(Lex,L):-
	var(Lex),!,
	write('Special treatment of arguments ? [no]/yes:  '), 
	obtain_answer1(L,n),nl,!.
obtain_special(L,L).

obtain_depth(Depth,D):-
	var(Depth),!,
	write('Deeper analysis ? [no]/yes:  '), 
	obtain_answer1(D,n),nl,!.
obtain_depth(D,D).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
perform_status(Inner,Lex,Depth):-
	((Inner='y',inner)
	;
	(Inner='n',noinner)
	),
	((Lex='y',lex)
	;
	(Lex='n',nolex)
	),
	((Depth='y',ccStand)
	;
	(Depth='n',noccStand)
	),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
perform_prover_0(Prover,FileOut,Rules):-
	on_exception(_,perform_prover(Prover,FileOut,Rules),prover_error(Prover)),!.

perform_prover(5,FileOut,Rules):-!,		
	(
	 (FileOut='', rpo(Rules))
	 ;
	 (\+FileOut='', rpo(Rules,FileOut), 
		write('The prover has finished.'),nl,
		write('The result is presented in the file '),
		write(FileOut),nl)
	),!.

perform_prover(Prover,FileOut,Rules):-		
	proverStat(Prover,GenCons,Mod),
	(
	 (FileOut='', ordre_mspo(Rules,GenCons,Mod))
	 ;
	 (\+FileOut='',
		ordre_mspo(Rules,FileOut,GenCons,Mod), 
		write('The prover has finished.'),nl,
		write('The result is presented in the file '),
		write(FileOut),nl)
	),!.


proverStat(1,twosteps,disjConS).
proverStat(2,unaun,disjConS).
proverStat(3,twosteps,hier).
proverStat(4,unaun,hier).

prover_error(Prover):-
	told,
	clean_end,
	(( Prover>=4,!,nl,
	   write('The system cannot treat this term rewriting system.')
	 )
	 ;
	 (nl,write('This prover cannot treat this term rewriting system.'),
	  nl,write('Try with another prover.')
	 )
	),!. 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Operacions de lectura

obtainNameFile(Name):-
	get0(C0),
	salta_blancs(C0,C),
	(
	 ((C=13;C=10;C=46),W=[],flush1(C))
	;
	 (C=39, obtainNameFile1(C,W))
	;
	 (\+C=39,obtainNameFile2(C,W))
	),!,
	name(Name,W).


% file name  between ' '
obtainNameFile1(39,W):-
	get0(C),
	restName1(C,W),!.

restName1(13,_):-
	write('Error in the file name.'),nl,flush1(13),!,fail.
restName1(10,_):-
	write('Error in the file name.'),nl,flush1(10),!,fail.
restName1(39,[]):-!,flush1(39).
restName1(C,[C|W]):-
	correctChar(C),
	get0(C1),!,
	restName1(C1,W),!.

obtainNameFile2(C,[]):-
	(C==13;C==10;C==46),!,flush1(C).	
obtainNameFile2(C,[C|W]):-
	correctChar(C),
	get0(C1),
	obtainNameFile2(C1,W),!.


correctChar(95):-!.
correctChar(X):- X>44 , X<58,!.
correctChar(X):- X>64 , X<91,!.
correctChar(X):- X>96 , X<123,!.
correctChar(X):- nl,write('Error in the file name.'),nl,write(' '),	
	flush1(X),!,fail.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

readWord(N):-
	get0(C0),
	salta_blancs(C0,C),
	obtainWord(C,W),
	name(N,W).

obtainWord(C,[]):-
	(C==13;C==10;C==46),!,flush1(C).
obtainWord(C,[C|W]):-
	get0(C1),
	obtainWord(C1,W),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

obtain_answer1(Help,Default):-
	readWord(H), 
	((H='',Help=Default);
	 (\+H='',ok_answer(H,Help))
	),!.
obtain_answer1(Help,Default):-
	write('Please enter y/n: '),
	obtain_answer1(Help,Default),!.	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

salta_blancs(32,COut):-!,
	get0(C),
	salta_blancs(C,COut).
salta_blancs(C,C).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


flush1(10):-!.
flush1(13):-!.
flush1(_):-get0(C),flush1(C),!.
